  /* Zadatak 10.1.8. (str. 113)

     Napisite funkciju koja prima jedan cjelobrojni parametar n iz N,
     te vraca 1 ako je n prost, odnosno 0, ako n nije prost.

     Bolje rjesenje - testiranjem djelitelja do (int) sqrt(n).

     Dodana je stoperica (v. Prog2, zadnje predavanje) i ispis vremena.
  */

#include <stdio.h>
#include <math.h>
#include <time.h>


    /* Funkcija za procesorsko vrijeme u sekundama. */

double dsecnd (void) {
    return (double)( clock( ) ) / CLOCKS_PER_SEC;
}


    /* Funkcija za provjeru je li broj prost. */

int is_prime(int n)
{
    int d;        /* Potencijalni djelitelj. */
    int max_d;    /* Maksimalni potencijalni djelitelj. */

        /* Brojevi <= 1 nisu prosti (ignoriramo <= 0). */
    if (n <= 1) return 0;

        /* Testiraj sve moguce djelitelje od n.
           U ovoj (BOLJOJ) varijanti, od 2 do (int) sqrt(n). */

    max_d = (int) sqrt(n);    /* Korektno je zaokruzivanje! */

    d = 2;
    while (d <= max_d) {
        if (n % d == 0) return 0;    /* Nije prost. */
        ++d;
    }
    return 1;
}

    /* Glavni program za test funkcije:
       Funkcija je postala prebrza za stopericu!
       Nadji desettisuciti prosti broj veci ili jednak od ucitanog n. */

int main(void)
{
    int n;
    int max_k = 10000;    /* Broj prostih brojeva >= n. */
    int k = 0;            /* Brojac prostih >= n. */
    double t1, t2, time;    /* Vremena za stopericu. */

    printf(" Upisi broj n: ");
    scanf("%d", &n);
    printf("\n Trazim %d. prosti broj >= %d\n", max_k, n);

    t1 = dsecnd( );    /* Pocetak mjerenja vremena. */

    while (1) {
        if (is_prime(n)) ++k;
        if (k >= max_k) break;
        ++n;
    }

    t2 = dsecnd( );    /* Kraj mjerenja vremena. */

    printf(" Trazeni prosti broj = %d\n", n);

        /* Ispis utrosenog vremena. */
    time = t2 - t1;
    printf("\n Utroseno vrijeme = %g s\n", time);

    return 0;
}
